﻿//Bert Carrein
//30/11/2009
//Groep: L2 (2MCT)

package actionscript{

	// Imports
	import flash.display.*;
	import flash.events.*;
	import flash.ui.Keyboard;
	import flash.ui.Mouse;
	import flash.utils.Timer;
	import flash.net.*;
	import flash.display.Sprite;
	import flash.text.*;

	import fl.motion.Color;
	import fl.transitions.easing.*;
	import com.greensock.*;

	// Class definitie
	public class FlashGame extends MovieClip {

		//All fields
		//Containers
		private var gameContainer:MovieClip;
		private var throwerContainer:MovieClip;
		private var enemyContainer:MovieClip;
		private var eiContainer:MovieClip;
		private var catcherContainer:MovieClip;
		private var lifesContainer:MovieClip;
		private var backgroundContainer:MovieClip;
		private var maskContainer:MovieClip;

		//Spelgegevens
		private var winnaars:Array = new Array();
		private var score:int=0;
		private var level1Score:int=0;
		private var level2Score:int=0;
		private var level3Score:int=0;
		private var level4Score:int=0;
		private var lifes:int=5;
		private var totalLifes:int=5;
		private var level:int=1;
		private var countAsteroids:int=0;
		private var isPaused:Boolean=false;

		//Bewegingsvariabelen
		private var speed:Number=0;
		private var pausedSpeed:Number=0;
		private var maxspeed:Number=2.5;
		private var zin:Number;
		private var keyPressedRight:Boolean;
		private var keyPressedLeft:Boolean;
		private var keyPressedUp:Boolean;
		private var keyPressedDown:Boolean;

		//Extra
		private var spaceBarPressed:Boolean;
		private var throwerExists:Boolean;
		private var scoreField:TextField;
		private var gameTitle:TextField;
		private var tmrAsteroids:Timer;
		private var tmrSmallAsteroids:Timer;
		private var thrower:Thrower;
		private var myTweens:Array=new Array();

		//Levels
		private var tmrLevelSeconds:Timer;
		private var counterLevelSeconds:int=0;
		private var counterLevelAsteroids:int=0;
		private var counterLevelEnemies:int=0;
		private var nextLevel:NextLevel;
		private var tmrEnemyShip:Timer;
		private var tmrEnemyShoot:Timer;
		private var enemyShot:int;

		//Startup
		private var startup:StartupWindow;
		private var backgroundImage:MovieClip;
		private var startupContainer:MovieClip;
		private var options:OptionsWindow;
		private var highScores:HighscoresWindow;
		private var winnaarScore:HighScore;

		//Pause & Gameover
		private var pausedGame:PausedWindow;
		private var gameStop:GameOverWindow;
		private var masker:Mask;
		private var text1:TextField;
		private var text2:TextField;
		private var text3:TextField;
		private var text4:TextField;

		//Connectie
		private var settings:SettingsLoader;
		private var connection:NetConnection = new NetConnection();

		// Constructor
		public function FlashGame():void {
			buildStartup();
			initConnection();
		}

		//Build startup
		private function buildStartup():void {
			startupContainer=new MovieClip();
			startup=new StartupWindow();
			startupContainer.addChild(startup);
			startup.mcMenu.btnNewGame.addEventListener(MouseEvent.MOUSE_UP,newGameHandler);
			startup.mcMenu.btnOptions.addEventListener(MouseEvent.MOUSE_UP,optionsHandler);
			startup.mcMenu.btnHighScores.addEventListener(MouseEvent.MOUSE_UP,highScoresHandler);
			addChild(startupContainer);
		}

		//Handlers on startup
		//New game
		private function newGameHandler(event:MouseEvent):void {
			startupContainer.visible=false;
			Mouse.hide();
			buildGame();
		}

		//Options
		private function optionsHandler(event:MouseEvent):void {
			startup.mcMenu.visible=false;
			options=new OptionsWindow();
			options.alpha=0;
			options.x=5*stage.stageWidth/8;
			options.y=stage.stageHeight/2;
			startupContainer.addChild(options);
			TweenLite.to(options,0.5,{alpha:1,ease:Regular.easeIn});
			options.btnOptionsGoBack.addEventListener(MouseEvent.MOUSE_UP,optionsMouseHandler);
		}
		private function optionsMouseHandler(event:MouseEvent):void {
			options.btnOptionsGoBack.removeEventListener(MouseEvent.MOUSE_UP,optionsMouseHandler);

			startupContainer.removeChild(options);
			startup.mcMenu.visible=true;
		}

		//Highscores
		private function highScoresHandler(event:MouseEvent):void {
			startup.mcMenu.visible=false;
			highScores=new HighscoresWindow();
			highScores.alpha=0;
			highScores.x=5*stage.stageWidth/8;
			highScores.y=stage.stageHeight/2;
			startupContainer.addChild(highScores);
			TweenLite.to(highScores,0.5,{alpha:1,ease:Regular.easeIn});
			highScores.btnHighscoresGoBack.addEventListener(MouseEvent.MOUSE_UP,highscoresMouseHandler);

			getHighScores();
		}
		private function highscoresMouseHandler(event:MouseEvent):void {
			highScores.btnHighscoresGoBack.removeEventListener(MouseEvent.MOUSE_UP,highscoresMouseHandler);

			startupContainer.removeChild(highScores);
			startup.mcMenu.visible=true;
		}
		private function visualiseHighScores(winnaars:Array):void {
			if (winnaars.length==0) {
				winnaarScore=new HighScore();
				winnaarScore.txtName.text="No highscores yet";
				winnaarScore.txtScore.text="";
				winnaarScore.txtName.embedFonts=true;
				highScores.addChild(winnaarScore);
				winnaarScore.x=0;
				winnaarScore.y=- highScores.width/2+75;
			} else {
				var iTeller:int=0;
				for each (var winnaar:Object in winnaars) {
					winnaarScore=new HighScore();
					winnaarScore.txtScore.text=""+winnaar.score;
					winnaarScore.txtScore.embedFonts=true;
					winnaarScore.txtName.text=unescape(winnaar.name);
					winnaarScore.txtName.embedFonts=true;

					highScores.addChild(winnaarScore);
					winnaarScore.alpha=0;
					winnaarScore.scaleX=1.5;
					winnaarScore.scaleY=1.5;
					winnaarScore.x=0;
					winnaarScore.y=- highScores.width/2+iTeller*25+75;

					TweenLite.to(winnaarScore,0.2,{delay:iTeller*0.1+0.3,scaleX:1,scaleY:1,alpha:1,ease:Regular.easeOut});
					iTeller++;
				}
			}
		}

		//Build Game
		private function buildGame():void {
			gameContainer=new MovieClip();
			backgroundContainer=new MovieClip();
			gameContainer.addChild(backgroundContainer);
			eiContainer=new MovieClip();
			gameContainer.addChild(eiContainer);
			catcherContainer=new MovieClip();
			gameContainer.addChild(catcherContainer);
			throwerContainer=new MovieClip();
			gameContainer.addChild(throwerContainer);
			enemyContainer=new MovieClip();
			gameContainer.addChild(enemyContainer);
			addChild(gameContainer);

			maskContainer=new MovieClip();
			addChild(maskContainer);

			maskContainer.graphics.beginFill(0XFF0000,0.4);
			maskContainer.graphics.drawRect(0,0,stage.stageWidth,stage.stageHeight);
			maskContainer.graphics.endFill();

			gameContainer.mask=maskContainer;

			addNewThrower();

			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			
			level=1;
			score=0;
			level1Score=0;
			level2Score=0;
			level3Score=0;
			level4Score=0;
			counterLevelAsteroids=0;
			counterLevelEnemies=0;

			addBackground(1);
			addGameInfo();
			addGameTitle();
			addScoreField();
			addLifes(lifes);

			gameContainer.addEventListener(Event.ENTER_FRAME, throwerBewegen);

			keyPressedRight=false;
			keyPressedLeft=false;
			keyPressedUp=false;
			keyPressedDown=false;

			tmrAsteroids=new Timer(3500);
			tmrAsteroids.addEventListener(TimerEvent.TIMER,throwAsteroid);
			tmrAsteroids.start();

			tmrLevelSeconds=new Timer(1000);
			tmrLevelSeconds.addEventListener(TimerEvent.TIMER,levelSecondsTick);
			tmrLevelSeconds.start();

			isPaused=false;
			stage.focus=this;
		}
		
		//KeyDownHandler
		private function keyDownHandler(e:KeyboardEvent):void {
			if (isPaused==false) {
				switch (e.keyCode) {
					case 39 :
						keyPressedRight=true;
						break;
					case 37 :
						keyPressedLeft=true;
						break;
					case 38 :
						keyPressedUp=true;
						break;
					case 40 :
						keyPressedDown=true;
						break;
				}

				//Kogel schieten bij het drukken op de spatiebalk
				if (e.keyCode==32&&spaceBarPressed==false&&throwerExists==true) {
					throwSomething();
					spaceBarPressed=true;
				}
			}
		}

		//KeyUpHandler
		private function keyUpHandler(e:KeyboardEvent):void {
			if (isPaused==false) {
				switch (e.keyCode) {
					case 39 :
						keyPressedRight=false;
						break;
					case 37 :
						keyPressedLeft=false;
						break;
					case 38 :
						keyPressedUp=false;
						break;
					case 40 :
						keyPressedDown=false;
						break;
				}

				if (e.keyCode==32) {
					spaceBarPressed=false;
				}

				if (e.keyCode==27) {
					pauseGame();
				}
			} else if (e.keyCode==27) {
				resumeGame();
			}
		}

		//Thrower bewegen
		private function throwerBewegen(e:Event):void {
			//Motor
			if (keyPressedUp==true) {
				thrower.gotoAndStop(2);
			} else {
				thrower.gotoAndStop(1);
			}

			//Draaien
			if (keyPressedLeft==true) {
				thrower.rotation-=4;
			}
			if (keyPressedRight==true) {
				thrower.rotation+=4;
			}

			//Snelheid verhogen
			if (keyPressedUp==true) {
				speed+=0.02;
				if (speed>maxspeed) {
					speed=maxspeed;
				}

				if (zin<thrower.rotation) {
					if (thrower.rotation-zin>180) {
						zin+=360;
					}
				} else if (zin>thrower.rotation) {
					if (zin-thrower.rotation>180) {
						zin-=360;
					}
				}

				var firstSpeed:Number;

				if (zin<thrower.rotation) {
					zin+=2;
					if (zin>thrower.rotation) {
						zin=thrower.rotation;
					}
				} else if (zin>thrower.rotation) {
					zin-=2;
					if (zin<thrower.rotation) {
						zin=thrower.rotation;
					}
				}
			}

			//Snelheid verminderen
			if (keyPressedDown==true&&speed>- maxspeed/2&&speed>0) {
				speed-=0.02;
				if (speed<0) {
					speed=0;
				}
			}

			if (speed==0) {
				zin=thrower.rotation;
			}

			thrower.x+=speed*Math.cos(zin*Math.PI/180);
			thrower.y+=speed*Math.sin(zin*Math.PI/180);

			//Afbeelding blijft op de stage en beweegt mee met thrower
			backgroundImage.x-=speed*Math.cos(zin*Math.PI/180)*0.2;
			backgroundImage.y-=speed*Math.sin(zin*Math.PI/180)*0.2;
			if (backgroundImage.x>0) {
				backgroundImage.x=0;
			}
			if (backgroundImage.x+backgroundImage.width<stage.stageWidth) {
				backgroundImage.x=stage.stageWidth-backgroundImage.width;
			}
			if (backgroundImage.y>0) {
				backgroundImage.y=0;
			}
			if (backgroundImage.y+backgroundImage.height<stage.stageHeight) {
				backgroundImage.y=stage.stageHeight-backgroundImage.height;
			}

			//Thrower blijft op de stage
			if (thrower.x<0) {
				thrower.x=stage.stageWidth;
			}
			if (thrower.x>stage.stageWidth) {
				thrower.x=0;
			}
			if (thrower.y<0) {
				thrower.y=stage.stageHeight;
			}
			if (thrower.y>stage.stageHeight) {
				thrower.y=0;
			}
		}

		//Timer: Level seconds (welk level?)
		private function levelSecondsTick(event:TimerEvent):void {
			counterLevelSeconds++;

			if (level==1) {
				if (counterLevelSeconds>=90&&counterLevelAsteroids>=15) {
					tmrLevelSeconds.stop();
					gotoNextLevel();
					level++;
				}
			} else if (level==2) {
				if (counterLevelSeconds>=90&&counterLevelAsteroids>=15) {
					tmrLevelSeconds.stop();
					gotoNextLevel();
					level++;
				}
			} else if (level==3) {
				if (counterLevelSeconds>=100&&counterLevelAsteroids>=20) {
					tmrLevelSeconds.stop();
					gotoNextLevel();
					level++;
				}
			} else if (level==3) {
				if (counterLevelSeconds>=100&&counterLevelAsteroids>=20) {
					tmrLevelSeconds.stop();
					gotoNextLevel();
					level++;
				}
			} else if (level==4) {
				if (counterLevelSeconds>=100&&counterLevelAsteroids>=20) {
					tmrLevelSeconds.stop();
					gotoNextLevel();
					level++;
				}
			}
		}

		//Next level (timers aanmaken enz.)
		private function gotoNextLevel():void {
			if(isPaused==false){
				isPaused=true;
	
				stage.removeEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
				stage.removeEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
				gameContainer.removeEventListener(Event.ENTER_FRAME, throwerBewegen);
	
				keyPressedRight=false;
				keyPressedLeft=false;
				keyPressedUp=false;
				keyPressedDown=false;
	
				tmrAsteroids.stop();
				tmrLevelSeconds.stop();
				if (level>=3) {
					tmrEnemyShip.stop();
					tmrEnemyShoot.stop();
				}
				if (level>=4) {
					tmrSmallAsteroids.stop();
				}
				speed=0;
				counterLevelSeconds=0;
				counterLevelAsteroids=0;
	
				for each (var item in myTweens) {
					item[2].pause();
				}
	
				nextLevel=new NextLevel();
				gameContainer.addChild(nextLevel);
				nextLevel.x=stage.stageWidth/2;
				nextLevel.y=stage.stageHeight/2;
	
				tween1(nextLevel.nextLevelBG);
	
				Mouse.show();
	
				nextLevel.btnNextLevel.addEventListener(MouseEvent.MOUSE_UP,jumpToNextLevel);
	
				var bank:Font=new BankGothic();
				var format:TextFormat=new TextFormat();
				format.bold=true;
				format.color=0xFFFFFF;
				format.font=bank.fontName;
	
				var yPos=- nextLevel.height/2+180;
	
				text1=new TextField();
				text1.autoSize=TextFieldAutoSize.CENTER;
				text1.selectable=false;
				text1.embedFonts=true;
				text1.text="You just completed level "+level+"!";
				text1.x=0;
				text1.y=yPos;
				format.size=14;
				text1.setTextFormat(format);
	
				text2=new TextField();
				text2.autoSize=TextFieldAutoSize.CENTER;
				text2.selectable=false;
				text2.embedFonts=true;
				text2.text="Score: "+score;
				text2.x=0;
				text2.y=yPos+60;
				format.size=16;
				text2.setTextFormat(format);
	
				text3=new TextField();
				text3.autoSize=TextFieldAutoSize.CENTER;
				text3.selectable=false;
				text3.embedFonts=true;
				var totalScore=score+level1Score+level2Score+level3Score+level4Score;
				text3.text="Total score: "+totalScore;
				text3.x=0;
				text3.y=yPos+80;
				format.size=16;
				text3.setTextFormat(format);
	
				nextLevel.addChild(text1);
				nextLevel.addChild(text2);
				nextLevel.addChild(text3);
			}
		}

		//Build next level
		private function jumpToNextLevel(event:MouseEvent):void {
			isPaused=false;
			if (level==2) {
				addBackground(2);
				level1Score=score;
				tmrAsteroids.reset();
				tmrAsteroids=new Timer(2750);
				tmrAsteroids.addEventListener(TimerEvent.TIMER,throwAsteroid);
			} else if (level==3) {
				addBackground(3);
				level2Score=score;
				tmrEnemyShip=new Timer(35000);
				tmrEnemyShip.addEventListener(TimerEvent.TIMER,newEnemyShip);
				tmrEnemyShip.start();
				tmrEnemyShoot=new Timer(4000);
				tmrEnemyShoot.addEventListener(TimerEvent.TIMER,shootEnemyShip);
				tmrEnemyShoot.start();
			} else if (level==4) {
				addBackground(4);
				level3Score=score;
				tmrSmallAsteroids=new Timer(4000);
				tmrSmallAsteroids.addEventListener(TimerEvent.TIMER,throwSmallAsteroid);
				tmrSmallAsteroids.start();
				tmrEnemyShip.reset();
				tmrEnemyShip=new Timer(25000);
				tmrEnemyShip.addEventListener(TimerEvent.TIMER,newEnemyShip);
				tmrEnemyShip.start();
				tmrEnemyShoot.start();
			} else if (level==5) {
				addBackground(5);
				level4Score=score;
				tmrEnemyShip.reset();
				tmrEnemyShip=new Timer(15000);
				tmrEnemyShip.addEventListener(TimerEvent.TIMER,newEnemyShip);
				tmrEnemyShip.start();
				tmrEnemyShoot.reset();
				tmrEnemyShoot=new Timer(2500);
				tmrEnemyShoot.addEventListener(TimerEvent.TIMER,shootEnemyShip);
				tmrEnemyShoot.start();
				tmrSmallAsteroids.reset();
				tmrSmallAsteroids=new Timer(3000);
				tmrSmallAsteroids.addEventListener(TimerEvent.TIMER,throwSmallAsteroid);
				tmrSmallAsteroids.start();
			}

			if (lifesContainer.numChildren<totalLifes) {
				var leven:Thrower = new Thrower();
				leven.scaleX=0.4;
				leven.scaleY=0.4;
				leven.rotation=-45;
				leven.y=12;
				leven.x=(lifesContainer.numChildren)*(7+leven.width)+21;
				leven.gotoAndStop(2);
				lifesContainer.addChild(leven);
			}

			score=0;
			scoreField.text="0";
			gameTitle.text="Level "+level;
			formatInfoBarText(scoreField);
			formatInfoBarText(gameTitle);

			gameContainer.removeChild(nextLevel);
			while (throwerContainer.numChildren>0) {
				throwerContainer.removeChildAt(0);
			}
			addNewThrower();
			thrower.rotation=0;
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			gameContainer.addEventListener(Event.ENTER_FRAME, throwerBewegen);

			while (catcherContainer.numChildren > 0) {
				TweenLite.killTweensOf(catcherContainer.getChildAt(0));
				for each (var item1 in myTweens) {
					if (catcherContainer.getChildAt(0)==item1[0]) {
						item1[1]=false;
					}
				}
				catcherContainer.removeChildAt(0);
			}

			while (eiContainer.numChildren > 0) {
				TweenLite.killTweensOf(eiContainer.getChildAt(0));
				for each (var item2 in myTweens) {
					if (eiContainer.getChildAt(0)==item2[0]) {
						item2[1]=false;
					}
				}
				eiContainer.removeChildAt(0);
			}

			while (enemyContainer.numChildren > 0) {
				TweenLite.killTweensOf(enemyContainer.getChildAt(0));
				for each (var item3 in myTweens) {
					if (enemyContainer.getChildAt(0)==item3[0]) {
						item3[1]=false;
					}
				}
				enemyContainer.removeChildAt(0);
			}

			tmrAsteroids.start();
			tmrLevelSeconds.start();

			Mouse.hide();
			stage.focus=this;
		}
		
		//Game options (pause, resume, stop)
		//Pause game
		private function pauseGame():void {
			isPaused=true;

			keyPressedRight=false;
			keyPressedLeft=false;
			keyPressedUp=false;
			keyPressedDown=false;

			tmrAsteroids.stop();
			tmrLevelSeconds.stop();
			if (level>=3) {
				tmrEnemyShip.stop();
				tmrEnemyShoot.stop();
			}
			if (level>=4) {
				tmrSmallAsteroids.stop();
			}
			pausedSpeed=speed;
			speed=0;

			pauseTweens();
			newPausedWindow();
		}
		private function pauseTweens():void {
			for each (var item in myTweens) {
				item[2].pause();
			}
		}
		private function newPausedWindow():void {
			pausedGame=new PausedWindow();
			gameContainer.addChild(pausedGame);
			pausedGame.x=stage.stageWidth/2;
			pausedGame.y=stage.stageHeight/2;

			pausedGame.btnResumeGame.addEventListener(MouseEvent.MOUSE_UP,resumeGameHandler);
			pausedGame.btnGameOver.addEventListener(MouseEvent.MOUSE_UP,gameOverHandler);
			pausedGame.btnPausedOptions.addEventListener(MouseEvent.MOUSE_UP,pausedOptionsHandler);

			tween1(pausedGame.mcWindow);

			Mouse.show();
		}

		//Pause options
		private function pausedOptionsHandler(event:MouseEvent) {
			stage.removeEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.removeEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			masker=new Mask();
			masker.x=stage.stageWidth/2;
			masker.y=stage.stageHeight/2;
			pausedGame.visible=false;
			gameContainer.addChild(masker);
			options=new OptionsWindow();
			options.alpha=0;
			options.x=stage.stageWidth/2;
			options.y=stage.stageHeight/2;
			gameContainer.addChild(options);
			TweenLite.to(options,0.5,{alpha:1,ease:Regular.easeIn});
			options.btnOptionsGoBack.addEventListener(MouseEvent.MOUSE_UP,pausedOptionsMouseHandler);
		}
		private function pausedOptionsMouseHandler(event:MouseEvent):void {
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			options.btnOptionsGoBack.removeEventListener(MouseEvent.MOUSE_UP,pausedOptionsMouseHandler);

			gameContainer.removeChild(options);
			gameContainer.removeChild(masker);
			pausedGame.visible=true;
		}

		//Handler: game over
		private function gameOverHandler(event:MouseEvent):void {
			gameContainer.removeChild(pausedGame);
			gameOver();
		}

		//Stop game
		private function stopGame():void {
			backgroundContainer.removeChild(backgroundImage);
			level=1;
			score=0;
			level1Score=0;
			level2Score=0;
			level3Score=0;
			level4Score=0;
			lifes=totalLifes;
			speed=0;
			gameContainer.visible=false;
			startupContainer.visible=true;

			Mouse.show();
		}

		//Resume game
		private function resumeGame():void {
			gameContainer.removeChild(pausedGame);
			isPaused=false;

			speed=pausedSpeed;
			tmrAsteroids.start();
			tmrLevelSeconds.start();
			if (level>=3) {
				tmrEnemyShip.start();
				tmrEnemyShoot.start();
			}
			if (level>=4) {
				tmrSmallAsteroids.start();
			}

			for each (var item in myTweens) {
				if (item[1]==true) {
					item[2].play();
				}
			}

			Mouse.hide();
			stage.focus=this;
		}
		private function resumeGameHandler(event:MouseEvent) {
			resumeGame();
		}

		//Background
		private function addBackground(levelBG:int):void {
			if (levelBG==1) {
				backgroundImage=new BackgroundFirst();
			} else if (levelBG==2) {
				backgroundImage=new BackgroundSecond();
			} else if (levelBG==3) {
				backgroundImage=new BackgroundThird();
			} else if (levelBG==4) {
				backgroundImage=new BackgroundFourth();
			} else if (levelBG==5) {
				backgroundImage=new BackgroundFifth();
			}
			backgroundContainer.addChild(backgroundImage);
			backgroundImage.x=-(backgroundImage.x+stage.stageWidth)/2;
			backgroundImage.y=-(backgroundImage.y+stage.stageHeight)/2;
		}

		//Spaceship op stage zetten
		private function addNewThrower():void {
			if(throwerContainer.numChildren<1){
				thrower = new Thrower();
				throwerContainer.addChild(thrower);
			}
			thrower.x = ((stage.stageWidth/2)-(thrower.width/2));
			thrower.y = ((stage.stageHeight/2)-(thrower.height/2));
			zin=thrower.rotation;
			speed=0;
			throwerExists=true;
		}

		//Info bar + components (lifes, level, score)
		private function addGameInfo():void {
			var info:GameInfo=new GameInfo();
			info.x=0;
			info.y=0;
			info.height=34;
			info.width=stage.stageWidth*1.3;
			gameContainer.addChild(info);
		}

		//Title (level)
		private function addGameTitle():void {
			gameTitle=new TextField();
			gameTitle.autoSize=TextFieldAutoSize.CENTER;
			gameTitle.selectable=false;
			gameTitle.embedFonts=true;
			gameTitle.text="Level "+level;
			gameTitle.x=(stage.stageWidth/2)-(gameTitle.width/2);
			gameTitle.y=2.5;

			formatInfoBarText(gameTitle);
			gameContainer.addChild(gameTitle);
		}

		//Score field
		private function addScoreField():void {
			scoreField = new TextField();

			scoreField.autoSize=TextFieldAutoSize.RIGHT;
			scoreField.selectable=false;
			scoreField.embedFonts=true;
			scoreField.text="0";
			scoreField.x=stage.stageWidth-12;
			scoreField.y=2.5;

			formatInfoBarText(scoreField);
			gameContainer.addChild(scoreField);
		}

		//Lifes
		private function addLifes(lifes:int):void {
			lifesContainer=new MovieClip();
			gameContainer.addChild(lifesContainer);
			var top:int=12;
			var left:int=0;
			for (var i=1; i<=lifes; i++) {
				var leven:Thrower = new Thrower();
				leven.scaleX=0.4;
				leven.scaleY=0.4;
				leven.rotation=-45;
				var barWidth=lifes*leven.width+(lifes-1)*7;
				leven.y=top;
				leven.x=i*(7+leven.width)-7;
				leven.gotoAndStop(2);
				lifesContainer.addChild(leven);
			}
		}

		//Format text in info bar
		private function formatInfoBarText(field:TextField):void {
			var bank:Font=new BankGothic();
			var format:TextFormat=new TextFormat();

			format.color=0x00FF00;
			format.size=20;
			format.font=bank.fontName;

			field.setTextFormat(format);
		}

		//New enemy ship on stage
		private function newEnemyShip(e:TimerEvent):void {
			var enemy:EnemyShip = new EnemyShip();
			enemyContainer.addChild(enemy);
			var countEnemies=Math.floor(Math.random()*4+1);

			var xStart = Math.floor(Math.random()*(stage.stageWidth)+1);
			var yStart = Math.floor(Math.random()*(stage.stageHeight)+1);
			var xEnd = Math.floor(Math.random()*(stage.stageWidth)+1);
			var yEnd = Math.floor(Math.random()*(stage.stageHeight)+1);
			var time:int=10;
			var xDest:int;
			var yDest:int;

			if (countEnemies==1) {
				enemy.x=-50;
				enemy.y=yStart;
				xDest=stage.stageWidth+100;
				yDest=yEnd;
			} else if (countEnemies==2) {
				enemy.x=stage.stageWidth+50;
				enemy.y=yStart;
				xDest=-50;
				yDest=yEnd;
			} else if (countEnemies==3) {
				enemy.x=xStart;
				enemy.y=-50;
				xDest=xEnd;
				yDest=stage.stageHeight+100;
			} else if (countEnemies==4) {
				enemy.x=xStart;
				enemy.y=stage.stageHeight+50;
				xDest=xEnd;
				yDest=-50;
			}

			var myTween=new TweenLite(enemy,time,{y:yDest,x:xDest,ease:None.easeNone,onUpdate:hitTestThrower,onUpdateParams:["enemyShip",enemy],onComplete:removeEnemy,onCompleteParams:[enemy]});
			var arr=new Array();
			arr.push(enemy);
			arr.push(true);
			arr.push(myTween);
			myTweens.push(arr);
		}

		//Enemy ship shoots at thrower
		private function shootEnemyShip(event:TimerEvent):void {
			if (enemyContainer.numChildren>0) {
				if (enemyContainer.getChildAt(0).x>0&&enemyContainer.getChildAt(0).x<stage.stageWidth&&enemyContainer.getChildAt(0).y>0&&enemyContainer.getChildAt(0).y<stage.stageHeight) {
					var shoot:EnemyShoot = new EnemyShoot();

					var x0=enemyContainer.getChildAt(0).x;
					var y0=enemyContainer.getChildAt(0).y;

					var x1=thrower.x;
					var y1=thrower.y;

					var teller1=y1-y0;
					var teller2=x1-x0;
					var noemer=Math.pow(Math.pow((x1-x0),2)+Math.pow((y1-y0),2),(1/2));

					var rico=(y0-y1)/(x0-x1);
					var hoek;

					if (x0>x1) {
						hoek=Math.atan((y0-y1)/(x0-x1))*(180/Math.PI)+180;
					} else {
						hoek=Math.atan((y0-y1)/(x0-x1))*(180/Math.PI);
					}

					var min=hoek-15;
					var max=hoek+15;
					hoek=Math.floor(Math.random()*(max-min)+min);

					shoot.rotation=hoek;
					shoot.y=y0;
					shoot.x=x0;
					eiContainer.addChild(shoot);

					var size:Number;
					if (stage.stageWidth>stage.stageHeight) {
						size=stage.stageWidth;
					} else {
						size=stage.stageHeight;
					}
					size=size/2.4;

					hoek=hoek*(Math.PI/180);

					var yDestination:Number=y0+Math.sin(hoek)*size;
					var xDestination:Number=x0+Math.cos(hoek)*size;

					var myTween=new TweenLite(shoot,1-(speed/10),{y:yDestination,x:xDestination,onUpdate:hitTestThrower,onUpdateParams:["enemyShoot",shoot],alpha:0,ease:None.easeNone});
					var arr=new Array();
					arr.push(shoot);
					arr.push(true);
					arr.push(myTween);
					myTweens.push(arr);
					var shooter:EnemyShootSound = new EnemyShootSound();
					shooter.play();
				}
			}
		}

		//Delete enemy ship when leaving stage
		private function removeEnemy(mc:MovieClip) {
			tmrEnemyShoot.stop();
			try {
				TweenLite.killTweensOf(mc);
				enemyContainer.removeChild(mc);
				enemyShot=0;
			} catch (e:Error) {
			}
		}

		//New small asteroid on stage
		private function throwSmallAsteroid(e:TimerEvent):void {
			var asteroid:Catcher = new Catcher();
			catcherContainer.addChild(asteroid);
			countAsteroids=Math.floor(Math.random()*4+1);

			asteroid.scaleX=0.6;
			asteroid.scaleY=0.6;

			var xStart = Math.floor(Math.random()*(stage.stageWidth)+1);
			var yStart = Math.floor(Math.random()*(stage.stageHeight)+1);
			var xEnd = Math.floor(Math.random()*(stage.stageWidth)+1);
			var yEnd = Math.floor(Math.random()*(stage.stageHeight)+1);

			var time=8;
			var xDest=0;
			var yDest=0;

			if (countAsteroids==1) {
				asteroid.x=-50;
				asteroid.y=yStart;
				xDest=stage.stageWidth+100;
				yDest=yEnd;
			} else if (countAsteroids==2) {
				asteroid.x=stage.stageWidth+50;
				asteroid.y=yStart;
				xDest=-50;
				yDest=yEnd;
			} else if (countAsteroids==3) {
				asteroid.x=xStart;
				asteroid.y=-50;
				xDest=xEnd;
				yDest=stage.stageHeight+100;
			} else if (countAsteroids==4) {
				asteroid.x=xStart;
				asteroid.y=stage.stageHeight+50;
				xDest=xEnd;
				yDest=-50;
			}

			var myTween=new TweenLite(asteroid,time,{y:yDest,x:xDest,ease:None.easeNone,onUpdate:hitTestThrower,onUpdateParams:["asteroid",asteroid],onComplete:removeAsteroid,onCompleteParams:[asteroid]});
			var arr=new Array();
			arr.push(asteroid);
			arr.push(true);
			arr.push(myTween);
			myTweens.push(arr);
		}

		//New normal asteroid on stage
		private function throwAsteroid(e:TimerEvent):void {
			var asteroid:Catcher = new Catcher();
			catcherContainer.addChild(asteroid);
			countAsteroids=Math.floor(Math.random()*4+1);

			var xStart = Math.floor(Math.random()*(stage.stageWidth)+1);
			var yStart = Math.floor(Math.random()*(stage.stageHeight)+1);
			var xEnd = Math.floor(Math.random()*(stage.stageWidth)+1);
			var yEnd = Math.floor(Math.random()*(stage.stageHeight)+1);

			var time=15;
			var xDest=0;
			var yDest=0;

			if (countAsteroids==1) {
				asteroid.x=-50;
				asteroid.y=yStart;
				xDest=stage.stageWidth+100;
				yDest=yEnd;
			} else if (countAsteroids==2) {
				asteroid.x=stage.stageWidth+50;
				asteroid.y=yStart;
				xDest=-50;
				yDest=yEnd;
			} else if (countAsteroids==3) {
				asteroid.x=xStart;
				asteroid.y=-50;
				xDest=xEnd;
				yDest=stage.stageHeight+100;
			} else if (countAsteroids==4) {
				asteroid.x=xStart;
				asteroid.y=stage.stageHeight+50;
				xDest=xEnd;
				yDest=-50;
			}

			var myTween=new TweenLite(asteroid,time,{y:yDest,x:xDest,ease:None.easeNone,onUpdate:hitTestThrower,onUpdateParams:["asteroid",asteroid],onComplete:removeAsteroid,onCompleteParams:[asteroid]});
			var arr=new Array();
			arr.push(asteroid);
			arr.push(true);
			arr.push(myTween);
			myTweens.push(arr);
		}

		//Asteroid explodes
		private function blowupAsteroid(mc:MovieClip):void {
			var blowupAsteroid:Ontploffing = new Ontploffing();
			blowupAsteroid.x=mc.x;
			blowupAsteroid.y=mc.y;
			blowupAsteroid.scaleX=mc.scaleX;
			blowupAsteroid.scaleY=mc.scaleY;
			mc.visible=false;
			gameContainer.addChild(blowupAsteroid);
		}

		//Enemy explodes
		private function blowupEnemy(mc:MovieClip):void {
			var blowupEnemy:Ontploffing = new Ontploffing();
			blowupEnemy.x=mc.x;
			blowupEnemy.y=mc.y;
			blowupEnemy.scaleX=mc.scaleX;
			blowupEnemy.scaleY=mc.scaleY;
			mc.visible=false;
			gameContainer.addChild(blowupEnemy);
		}

		//Thrower explodes
		private function blowupThrower(mc:Thrower):void {
			var blowup:Ontploffing = new Ontploffing();
			blowup.x=mc.x;
			blowup.y=mc.y;

			var throwerBlowup:ThrowerBlowup = new ThrowerBlowup();
			throwerBlowup.x=mc.x;
			throwerBlowup.y=mc.y;
			throwerBlowup.rotation=mc.rotation;

			var crash:CrashSound = new CrashSound();
			crash.play();

			throwerContainer.removeChild(mc);
			gameContainer.addChild(blowup);
			gameContainer.addChild(throwerBlowup);
			throwerBlowup.gotoAndPlay(3);

			var myTween=new TweenLite(throwerBlowup,1,{alpha:0,onComplete:throwerDied,onCompleteParams:[throwerBlowup]});
		}

		//Hit test: is thrower being hit of an object?
		private function hitTestThrower(sMode:String,mc:MovieClip):void {
			if (mc.hitTestObject(thrower)&&throwerExists==true&&mc.visible==true) {
				if (sMode=="asteroid") {
					throwerExists=false;
					blowupAsteroid(mc);
					blowupThrower(thrower);
					keyPressedRight=false;
					keyPressedLeft=false;
					keyPressedUp=false;
					keyPressedDown=false;
					speed=0;
					tmrAsteroids.stop();
					if (level>=4) {
						tmrSmallAsteroids.stop();
					}
				} else if (sMode=="enemyShip") {
					throwerExists=false;
					blowupEnemy(mc);
					blowupThrower(thrower);
					keyPressedRight=false;
					keyPressedLeft=false;
					keyPressedUp=false;
					keyPressedDown=false;
					speed=0;
					tmrAsteroids.stop();
					tmrEnemyShip.stop();
					if (level>=4) {
						tmrSmallAsteroids.stop();
					}
				} else if (sMode=="enemyShoot") {
					throwerExists=false;
					blowupThrower(thrower);
					keyPressedRight=false;
					keyPressedLeft=false;
					keyPressedUp=false;
					keyPressedDown=false;
					speed=0;
					tmrAsteroids.stop();
					tmrEnemyShip.stop();
					if (level>=4) {
						tmrSmallAsteroids.stop();
					}
				}
			}

		}

		//Thrower was hit by an object and dies
		private function throwerDied(mc:MovieClip):void {
			if (isPaused==false) {
				while (catcherContainer.numChildren > 0) {
					TweenLite.killTweensOf(catcherContainer.getChildAt(0));
					for each (var item1 in myTweens) {
						if (catcherContainer.getChildAt(0)==item1[0]) {
							item1[1]=false;
						}
					}
					catcherContainer.removeChildAt(0);
				}

				while (eiContainer.numChildren > 0) {
					TweenLite.killTweensOf(eiContainer.getChildAt(0));
					for each (var item2 in myTweens) {
						if (eiContainer.getChildAt(0)==item2[0]) {
							item2[1]=false;
						}
					}
					eiContainer.removeChildAt(0);
				}

				while (enemyContainer.numChildren > 0) {
					TweenLite.killTweensOf(enemyContainer.getChildAt(0));
					for each (var item3 in myTweens) {
						if (enemyContainer.getChildAt(0)==item3[0]) {
							item3[1]=false;
						}
					}
					enemyContainer.removeChildAt(0);
				}

				if (lifesContainer.numChildren>1) {
					addNewThrower();
					thrower.gotoAndStop(0);
					lifesContainer.removeChildAt(lifesContainer.numChildren-1);
					if (isPaused==false) {
						tmrAsteroids.start();
						if (level>=3) {
							tmrEnemyShip.start();
						}
						if (level>=4) {
							tmrSmallAsteroids.start();
						}
					}
				} else if (lifesContainer.numChildren==1) {
					lifesContainer.removeChildAt(lifesContainer.numChildren-1);
					gameOver();
				} else {
					gameOver();
				}
			} else {
				if(throwerContainer.numChildren<1){
					addNewThrower();
				}
			}
		}

		//Game over, when score is high enough: in hiscores
		private function gameOver():void {
			isPaused=true;
			
			tmrAsteroids.stop();
			if (level>=3) {
				tmrEnemyShip.stop();
				tmrEnemyShoot.stop();
			}
			if (level>=4) {
				tmrSmallAsteroids.stop();
			}
			stage.removeEventListener(KeyboardEvent.KEY_DOWN, keyDownHandler);
			stage.removeEventListener(KeyboardEvent.KEY_UP, keyUpHandler);
			gameContainer.removeEventListener(Event.ENTER_FRAME, throwerBewegen);

			gameStop=new GameOverWindow();
			gameContainer.addChild(gameStop);
			gameStop.x=stage.stageWidth/2;
			gameStop.y=stage.stageHeight/2;

			tween1(gameStop.GameOverBG);

			score=score+level1Score+level2Score+level3Score+level4Score;
			Mouse.show();
			if (winnaars.length==0) {
				if (score>0) {
					fillInName("highscore");
				} else {
					fillInName();
				}
			} else if (winnaars.length<=9) {
				if (score>0) {
					if (winnaars[0].score<score) {
						fillInName("highest");
					} else {
						fillInName("highscore");
					}
				} else {
					fillInName();
				}
			} else {
				if (winnaars[9].score<score) {
					if (winnaars[0].score<score) {
						fillInName("highest");
					} else {
						fillInName("highscore");
					}
				} else {
					fillInName();
				}
			}
		}

		//Fill in your name (hiscores)
		private function fillInName(sMode:String="score"):void {
			gameStop.btnGoToMenu.visible=false;
			gameStop.btnGoToMenu.removeEventListener(MouseEvent.MOUSE_UP,gotoMenuHandler);

			var bank:Font=new BankGothic();
			var format:TextFormat=new TextFormat();
			format.bold=true;
			format.color=0xFFFFFF;
			format.font=bank.fontName;

			var yPos:int=240;

			text1=new TextField();
			text1.autoSize=TextFieldAutoSize.CENTER;
			text1.selectable=false;
			text1.embedFonts=true;
			if (sMode=="highest") {
				text1.text="Wow! You got the highest score!";
			} else if (sMode=="highscore") {
				text1.text="You got a new high score!";
			} else {
				text1.text="You didn't get a highscore!";
			}
			text1.x=stage.stageWidth/2-text1.width/2;
			text1.y=yPos;
			format.size=14;
			text1.setTextFormat(format);

			text2=new TextField();
			text2.autoSize=TextFieldAutoSize.CENTER;
			text2.selectable=false;
			text2.embedFonts=true;
			text2.text=""+score;
			text2.x=stage.stageWidth/2-text2.width/2;
			text2.y=yPos+25;
			format.size=17;
			text2.setTextFormat(format);

			text3=new TextField();
			text3.autoSize=TextFieldAutoSize.CENTER;
			text3.selectable=false;
			text3.embedFonts=true;
			text3.text="Please fill in your name:";
			text3.x=stage.stageWidth/2-text3.width/2;
			text3.y=yPos+65;
			format.size=14;
			text3.setTextFormat(format);

			text4=new TextField();
			text4.autoSize=TextFieldAutoSize.CENTER;
			text4.type=TextFieldType.INPUT;
			text4.embedFonts=true;
			text4.text="Your name";
			text4.maxChars=11;
			text4.x=stage.stageWidth/2-text4.width/2;
			text4.y=yPos+90;
			format.size=17;
			text4.setTextFormat(format);

			addChild(text1);
			addChild(text2);
			addChild(text3);
			addChild(text4);

			stage.addEventListener(KeyboardEvent.KEY_UP,nametextHandler);
		}
		private function nametextHandler(event:KeyboardEvent):void {
			if (event.keyCode==Keyboard.ENTER&&text4.text!=""&&text4.text!="Your name") {
				insertScore(text4.text,score);
				removeChild(text1);
				removeChild(text2);
				removeChild(text3);
				removeChild(text4);
				gameContainer.removeChild(gameStop);
				stage.removeEventListener(KeyboardEvent.KEY_UP,nametextHandler);
				stopGame();
			}
		}

		//Surrender
		private function gotoMenuHandler(event:MouseEvent):void {
			stopGame();
		}

		//Window tweens
		private function tween1(mc:MovieClip):void {
			TweenLite.to(mc,0.2,{alpha:0.18,ease:Regular.easeIn,onComplete:tween2,onCompleteParams:[mc]});
		}
		private function tween2(mc:MovieClip):void {
			TweenLite.to(mc,0.2,{alpha:0.16,ease:Regular.easeOut,onComplete:tween3,onCompleteParams:[mc]});
		}
		private function tween3(mc:MovieClip):void {
			TweenLite.to(mc,0.2,{alpha:0.18,ease:Regular.easeIn,onComplete:tween4,onCompleteParams:[mc]});
		}
		private function tween4(mc:MovieClip):void {
			TweenLite.to(mc,0.2,{alpha:0.20,ease:Regular.easeOut,onComplete:tween1,onCompleteParams:[mc]});
		}

		//Thrower shoots (by user)
		private function throwSomething() {
			var ei:Ei = new Ei();
			ei.rotation=thrower.rotation;
			ei.y=thrower.y;
			ei.x=thrower.x;
			eiContainer.addChild(ei);

			var size:Number;
			if (stage.stageWidth>stage.stageHeight) {
				size=stage.stageWidth;
			} else {
				size=stage.stageHeight;
			}
			size=size/2.4;

			var yDestination:Number=thrower.y+Math.sin(ei.rotation*(Math.PI/180))*size;
			var xDestination:Number=thrower.x+Math.cos(ei.rotation*(Math.PI/180))*size;

			var myTween=new TweenLite(ei,1-(speed/10),{y:yDestination,x:xDestination,alpha:0,ease:None.easeNone,onUpdate:hitTest,onUpdateParams:[ei],onComplete:completeThrowHandler,onCompleteParams:[ei]});
			var arr=new Array();
			arr.push(ei);
			arr.push(true);
			arr.push(myTween);
			myTweens.push(arr);
			var shooter:ShootSound = new ShootSound();
			shooter.play();
		}

		//Heeft de thrower iets geraakt?
		private function hitTest(ei:Ei) {
			if (ei.visible==true) {
				for (var i=0; i<catcherContainer.numChildren; i++) {
					if (catcherContainer.getChildAt(i).hitTestObject(ei)) {
						ei.visible=false;
						if (catcherContainer.getChildAt(i).scaleX!=0.6) {
							makeSmallAsteroids(4,catcherContainer.getChildAt(i).x,catcherContainer.getChildAt(i).y);
							updateScore(10);
							counterLevelAsteroids++;
						} else {
							updateScore(15);
						}

						TweenLite.killTweensOf(catcherContainer.getChildAt(i));
						var blowup:Ontploffing = new Ontploffing();
						blowup.x=catcherContainer.getChildAt(i).x;
						blowup.y=catcherContainer.getChildAt(i).y;
						blowup.scaleX=catcherContainer.getChildAt(i).scaleX;
						blowup.scaleY=catcherContainer.getChildAt(i).scaleY;
						gameContainer.addChild(blowup);

						for each (var item in myTweens) {
							if (catcherContainer.getChildAt(i)==item[0]) {
								item[1]=false;
							}
						}
						catcherContainer.removeChildAt(i);
						if (ei.visible==true) {
							eiContainer.removeChild(ei);
						}
					}
				}

				for(var i2=0;i2<enemyContainer.numChildren;i2++) {;
					if (enemyContainer.getChildAt(i2).hitTestObject(ei)) {
						ei.visible=false;
						enemyShot++;
						var mc:MovieClip=(enemyContainer.getChildAt(i2) as MovieClip);
						mc.gotoAndPlay(2);
	
						if (enemyShot>=3) {
							enemyShot=0;
							var crash:CrashSound = new CrashSound();
							crash.play();
							TweenLite.killTweensOf(enemyContainer.getChildAt(i2));
							var blowupEnemy:Ontploffing = new Ontploffing();
	
							blowupEnemy.x=enemyContainer.getChildAt(i2).x;
							blowupEnemy.y=enemyContainer.getChildAt(i2).y;
							blowupEnemy.scaleX=enemyContainer.getChildAt(i2).scaleX;
							blowupEnemy.scaleY=enemyContainer.getChildAt(i2).scaleY;
							gameContainer.addChild(blowupEnemy);
	
							for each (var item2 in myTweens) {
								if (enemyContainer.getChildAt(i2)==item2[0]) {
									item2[1]=false;
								}
							}
							enemyContainer.removeChildAt(i2);
							updateScore(200);
							counterLevelEnemies++;
						}
	
						if (ei.visible==true) {
							eiContainer.removeChild(ei);
						}
					}
				}
			}
		}

		//Update score
		private function updateScore(nieuweScore:Number):void {
			score+=nieuweScore;
			scoreField.text=""+score;
			formatInfoBarText(scoreField);
		}
		
		//kleine asteroides bij het raken van een normale asteroide
		private function makeSmallAsteroids(aantal:int,xPos:int,yPos:int):void {
			var asteroid:Catcher;
	
			for (var i=0; i<=aantal; i++) {
				asteroid = new Catcher();
				catcherContainer.addChild(asteroid);
				asteroid.x=xPos;
				asteroid.y=yPos;
	
				asteroid.scaleX=0.6;
				asteroid.scaleY=0.6;
	
	
				var place=Math.random()*360;
				var xDest = Math.cos(place*(Math.PI/180))*stage.stageWidth;
				var yDest = Math.sin(place*(Math.PI/180))*stage.stageHeight;
	
				if (xDest<=0) {
					xDest-=stage.stageWidth*1.2;
				} else if (xDest>0) {
					xDest+=stage.stageWidth*1.2;
				}
	
				if (yDest>=0) {
					yDest+=stage.stageHeight*1.2;
				} else if (yDest<0) {
					yDest-=stage.stageHeight*1.2;
				}
	
				var myTween=new TweenLite(asteroid,15,{x:xDest,y:yDest,ease:None.easeNone,onUpdate:hitTestThrower,onUpdateParams:["asteroid",asteroid],onComplete:removeAsteroid,onCompleteParams:[asteroid]});
				var arr=new Array();
				arr.push(asteroid);
				arr.push(true);
				arr.push(myTween);
				myTweens.push(arr);
			}
		}
		
		//Verwijder asteroide na het verlaten van de stage
		private function removeAsteroid(mc:MovieClip) {
			try {
				TweenLite.killTweensOf(mc);
				catcherContainer.removeChild(mc);
			} catch (e:Error) {
			}
		}
		
		//Verwijder 'kogel'
		private function completeThrowHandler(mc:MovieClip) {
			try {
				eiContainer.removeChild(mc);
			} catch (e:Error) {
			}
		}
		
		//Connecties en scores
		private function initConnection():void {
			settings=SettingsLoader.getInstance();
			settings.addEventListener(SettingsLoader.SETTINGS_LOADED,settingsLoadedHandler);
			settings.loadXML();
		}
	
		private function settingsLoadedHandler(event:Event):void {
			//connectie maken
			connection=new NetConnection();
			connection.connect(settings.httproot);
			//
			trace(settings.httproot);
			getAllHiScores();
		}
	
		private function getAllHiScores():void {
			var allResp:Responder=new Responder(allSuccesHandler1,faultHandler);
			connection.call("hiScore.getHiScores",allResp);
		}
	
		private function allSuccesHandler1(obj:Object) {
			trace("all high scores");
			var arr:Array=obj.serverInfo.initialData;
	
			for each (var item:Array in arr) {
				var winnaar:Object=new Object();
				winnaar.id=item[0];
				winnaar.name=item[1];
				winnaar.score=item[2];
	
				winnaars.push(winnaar);
			}
	
		}
	
		private function getHighScores():void {
			var allResp:Responder=new Responder(allSuccesHandler,faultHandler);
			connection.call("hiScore.getHiScores",allResp);
		}
	
		private function allSuccesHandler(obj:Object) {
			trace("all high scores");
			var arr:Array=obj.serverInfo.initialData;
			var allScores:Array=new Array();
			for each (var item:Array in arr) {
				var winnaar:Object=new Object();
				winnaar.id=item[0];
				winnaar.name=item[1];
				winnaar.score=item[2];
	
				allScores.push(winnaar);
			}
			visualiseHighScores(allScores);
		}
	
		private function insertScore(naam:String,score:int):void {
			//responder object aanmaken
			var resp:Responder=new Responder(succesHandler,faultHandler);
	
			//methode oproepen in backed class
			var paramObj:Object = new Object();
			paramObj.name=escape(naam);
			paramObj.score=score;
			connection.call("hiScore.insertScore",resp,paramObj);
		}
	
		private function succesHandler(obj:Object):void {
			trace("succes");
		}
	
		private function faultHandler(obj:Object):void {
			trace("fault");
		}
	
	}

}